class SinusoidMapping implements PlanarMapping
{
  PVector f( PVector p )
  {
    return new PVector( p.x + r * ( cos( p.x / W ) + sin( p.y / W ) ), p.y + r * ( cos( 4 * p.x / W ) + sin( p.y / W ) ) );
  }
  PVector df( int i, int j, PVector p )
  {
    float x = p.x; 
    float y = p.y;
    
    if ( i == 1 && j == 0 ) return new PVector( 1-(r*sin(x/W))/W,-(4*r*sin((4*x)/W))/W ); // dx
    if ( i == 0 && j == 1 ) return new PVector( (r*cos(y/W))/W,(r*cos(y/W))/W+1 ); // dy
    if ( i == 2 && j == 0 ) return new PVector( -(r*cos(x/W))/W/W,-(16*r*cos((4*x)/W))/W/W ); // dxx
    if ( i == 0 && j == 2 ) return new PVector( -(r*sin(y/W))/W/W,-(r*sin(y/W))/W/W ); // dyy
    if ( i == 3 && j == 0 ) return new PVector( (r*sin(x/W))/W/W/W,(64*r*sin((4*x)/W))/W/W/W ); // dxxx
    if ( i == 0 && j == 3 ) return new PVector( -(r*cos(y/W))/W/W/W,-(r*cos(y/W))/W/W/W ); // dyyy
    
    // all mixed partials are zero
    return new PVector( 0, 0 );
  }
  
  PVector boundDf( int n )
  {
    float m = pow( 4, n ) * r / pow( W, n );
    return new PVector( m, m );
  }
  
  float r = 48.0;
  float W = 196.0;  
}
